package cokr.xit.fims.rcvm.web;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

import cokr.xit.base.web.ApplicationController;

import cokr.xit.fims.rcvm.Rcvmt;
import cokr.xit.fims.rcvm.RcvmQuery;
import cokr.xit.fims.rcvm.service.Rcvm01Service;

/**수납 대장 서비스의 웹 컨트롤러
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-08-31	JoJH 최초 작성
 * ================================
 * </pre>
 */
@RequestMapping(name = "수납 대장", value = "/rcvmt")
public class Rcvm01Controller extends ApplicationController {

	/**수납 대장 서비스*/
	@Resource(name = "rcvm01Service")
	private Rcvm01Service rcvm01Service;

	/**수납 대장 관리 메인화면(rcvmt/rcvmt-main)을 연다.
	 * 조건없는 {@link #getRcvmtList(RcvmtQuery) 수납 대장 조회 결과}를 포함시킨다.
	 * @return /rcvmt/rcvmt-main
	 */
	@RequestMapping(name = "수납 대장 메인", value = "/010/main.do")
	public ModelAndView main() {
		ModelAndView mav = getRcvmtList(new RcvmQuery().setPageNum(1));

		mav.setViewName("/rcvmt/rcvmt-main");

		return mav.addObject("rcvmtList", toJson(mav.getModel().get("rcvmtList")));
	}

	/**수납 대장 목록을 조회하여 반환한다.<br />
	 * {@link RcvmtService#getRcvmtList(RcvmtQuery)} 참고
	 * @param req 수납 대장 조회 조건
	 * @return jsonView
	 * <pre><code> {
	 *     "rcvmtList": [수납 대장 목록]
	 *     "rcvmtStart": 수납 대장 목록 시작 인덱스
	 *     "rcvmtFetch": 한 번에 가져오는 수납 대장 목록 수
	 *     "rcvmtTotal": 조회 결과 찾은 전체 수납 대장 수
	 * }</code></pre>
	 */
	@RequestMapping(name = "수납 대장 조회", value = "/010/list.do")
	public ModelAndView getRcvmtList(RcvmQuery req) {
		List<?> result = rcvm01Service.getRcvmtList(setFetchSize(req));

		return setCollectionInfo(new ModelAndView("jsonView"), result, "rcvmt");
	}

	/**수납 대장를 등록한다.
	 * @param rcvmt 수납 대장 정보
	 * @return jsonView
	 * <pre><code> {
	 *     "saved": 등록되었으면 true, 그렇지 않으면 false
	 * }</code></pre>
	 */
	@PostMapping(name = "수납 대장 등록", value = "/010/create.do")
	public ModelAndView create(Rcvmt rcvmt) {
		boolean saved = rcvm01Service.createRcvmt(rcvmt);

		return new ModelAndView("jsonView")
			.addObject("saved", saved);
	}

	/**수납 대장 정보를 수정한다.
	 * @param rcvmt 수납 대장 정보
	 * @return jsonView
	 * <pre><code> {
	 *     "saved": 수정되었으면 true, 그렇지 않으면 false
	 * }</code></pre>
	 */
	@PostMapping(name = "수납 대장 수정", value = "/010/update.do")
	public ModelAndView update(Rcvmt rcvmt) {
		boolean saved = rcvm01Service.updateRcvmt(rcvmt);

		return new ModelAndView("jsonView")
			.addObject("saved", saved);
	}

	/**지정한 수납 대장를 제거한다.
	 * @param rcvmtIDs 수납 대장 아이디
	 * @return jsonView
	 * <pre><code> {
	 *     "affected": 저장된 정보수
	 *     "saved": 저장되었으면 true, 그렇지 않으면 false
	 * }</code></pre>
	 */
	@PostMapping(name = "수납 대장 제거", value = "/010/remove.do")
	public ModelAndView remove(Rcvmt rcvmt) {
		boolean saved = rcvm01Service.removeRcvmt(rcvmt);

		return new ModelAndView("jsonView")
			.addObject("saved", saved);
	}

}
